/****************************************************************
ConfigServer.h
CS 481 - Team A
Spring 1997
Hummingbird Project - Dr. Frincke
Coded by: Pete Neisen
Description: This file is the class definition for the configuration
             server object. This server waits for connections from
	     the manager and then executes the SQL commands it sends.
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _ConfigServer_h
#define _ConfigServer_h

#include "Hummer.h"                // Global hummer defines
#include "sock_cli.h"
#include "sock_serv.h"
#include <unistd.h>
#include <string.h>
//#include <time.h>
#include <sys/time.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif /* HAVE_SYS_IOCTL_H */

#ifdef HAVE_TERMIOS_H
#include <termios.h>
#define USING_TERMIOS
#endif /* HAVE_TERMIOS_H */

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif /* HAVE_FCNTL_H */

#include <Hummer_PG.h>

class ConfigServer
{
  // Data;
 private:
  sock_serv *InSocket;
  sock_cli *ConnectedSocket;
  int Port;
  int ServerRun;

// Methods

private:
  int ProcRequest(void);
public:
  ConfigServer();
  ConfigServer(int NewPort);
  ~ConfigServer();
  void StartServer(void);
  void KillServer(void);
};
  
#endif
