#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

package Lastlib;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw($usr_index $tty_index $host_index 
	     $stime_index $etime_index $duration_index
	     @data create_LoL time_stamp_strip duration_stamp_strip
	     sub_index_decrement sub_index_increment);

#<usr> <ttyp> <host> <wday> <month> <mday> <stime> <-> <etime> <duration>

$usr_index        = 0;
$tty_index        = 1;
$host_index       = 2;
$stime_index 	  = 6;
$etime_index      = 8;
$duration_index   = 9;


#############################################################
# Create a list of lists from the Unix last command.
#############################################################
sub create_LoL {
 local($count, @usr) = @_;
 # last types:  hp last -R,  solaris last
   open (LAST, "&LAST_TYPE& $count @usr|") || die "Can't open storage file.\n";
     while (<LAST>)  {   
        push @data, [ split ] ;
     }
   close (LAST);   
@data;
}



#############################################################
# Strip the colons from the time stamp.
#############################################################
sub time_stamp_strip {
 local($index) = @_;
    $data[$index][$stime_index] =~ s/://g;
    $data[$index][$etime_index] =~ s/://g;
}



#############################################################
# Strip the parenthesis and colons from the duration stamp.
#############################################################
sub duration_stamp_strip {
 local($index) = @_;
    $data[$index][$duration_index] =~ s/\(//g;
    $data[$index][$duration_index] =~ s/://g; 
    $data[$index][$duration_index] =~ s/\)//g;
} 



#############################################################
# Decrement sub index.
#############################################################
sub sub_index_decrement {
    $stime_index      -= 1;
    $etime_index   -= 1;
    $duration_index   -= 1;  
}



#############################################################
# Increment sub index.
#############################################################
sub sub_index_increment {
    $stime_index      += 1;
    $etime_index   += 1;
    $duration_index   += 1;
}

1;
