/****************************************************************
LevelCon.h
CS 481 - Team E
Spring 1998
Hummingbird Project - Dr. Frincke
Coded by: Jamie Marconi
Description: This is the class definition for the level container object.
             The container organizes and handles the individual levels. 
*****************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _LevelCon_h
#define _LevelCon_h

#include "Hummer.h"           // Global Hummer defines
#include "Level.h"            // Level object
#include "ConvertIP.h"        // Convert IP function

class LevelCon
{
// Data
private:
  Level *Head;
  Level *Last;
  int DefaultTrustLevel;
  int DefaultCoopLevel;
  int DefaultIntegLevel;

// Methods
public:
  LevelCon();
  ~LevelCon();
  int AddLevel(Level *NewLevel);
  void SetDefaultTrust(int Level);
  void SetDefaultCoop(int Level);
  void SetDefaultInteg(int Level);
  int GetTrust(char *HostIP);  
  int GetCoop(char *HostIP);
  int GetInteg(char *HostIP);
};
  

#endif
