.TH TOOLI 1 "Jan 28, 1997" "TOOLI" "TOOLI"

.\"
.\" Hummer manual page.
.\" Author: Jamie Marconi <marc9442@cs.uidaho.edu>
.\"

.SH NAME
ToolI \- HummingBird data collection Tool Interface

.SH SYNOPSIS
.B ToolI
.BI \-m " mesgtext"
.BI \-d " date"
.BI \-t " time"
.BI \-h " hostname"
.ti +6n
[
.BI \-f " file"
]
[
.BI \-s " tool"
]

.SH DESCRIPTION
The
.BToolI
command is called by the data gathering tools. Its only job is to pass the
plain text messages into the Hummer. It passes the messages to the Hummer
through network sockets. \fBToolI\fP takes the messages as command line
parameters.

.SH OPTIONS
The following options are supported:
.TP 15
.B \-m \f2mesgtext\f1
\fBRequired Field\fP. \f2msgtext\f1 is the text portion of the message sent to the
Hummer. 
.TP
.B \-d \f2date\f1
\fBRequired Field\fP. \f2date\f1 is the Date on which the message was
generated.  \f2date\f1 is in the form:
.RS
\f2yyyymmdd\f1
.sp 1n
where
.sp 1n
.PD 0
.TP
.I yyyy
will represent the year,
.TP
.I mm
the month, and
.TP
.I dd
the day.
.RE
.PD
.IP
The
.IR mm ,
.I  dd
and
.I  yyyy
fields will be two-digit or four-digit, respectfully, decimal integers padded on the left with zeros.

.TP
.B \-t \f2time\f1
\fBRequired Field\fP. \f2time\f1 is the Time at which the message generated.
\f2time\f1 is in the form:
.RS
\f2hhmmss\f1
.sp 1n
where
.sp 1n
.PD 0
.TP
.I hh
will represent the hour,
.TP
.I mm
the minute, and
.TP
.I dd
the second.
.RE
.PD
.IP
The
.IR hh ,
.I  mm
and
.I  ss
fields will be two-digit decimal integers padded on the left with zeros.

.TP
.B \-h \f2hostname\f1
\fBRequired Field\fP. \f2hostname\f1 is the hostname from which the message
was generated.

.TP
.B \-f \f2file\f1
\f2file\f1 is the filename of the log file from which the message was extracted.

.TP
.B \-s \f2tool\f1
\f2tool\f1 is the name of the Data Gathering Tool from which the message was
created.

.SH EXAMPLES
The command:
.sp
.nf
    % ToolI -m 'Test Message' -d 19980127 -t 110724 -h testhost.test.net
.fi

Sends the Hummer message \fBTest Message\fP from host \fBtesthost.test.net\fP
on \fBJan 27 1998\fP at \fB11:07:24am\fP.

.SH SEE ALSO
Server(1), ConClient(1), ConServ(1), hummer(1) 

.SH AUTHOR
Jamie Marconi, University of Idaho Department of Computer Science