
#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

package Toollib;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(atoiMonth forktoBg handler $sleepTime $hostname
	     $host $logfile);


#############################################################
# Global Variables to all Tools
#############################################################
 $logfile = "null";
 
 use Sys::Hostname;
 $host = hostname();
 
 $hostname = (gethostbyname $host)[0];
 $sleepTime = 5;



#############################################################
# Convert the month from an alpha to numeric representation
#############################################################
sub atoiMonth {
 local($month) = @_;

        $month =~ s/Jan/01/;        $month =~ s/Feb/02/;
        $month =~ s/Mar/03/;        $month =~ s/Apr/04/;
        $month =~ s/May/05/;        $month =~ s/Jun/06/;
        $month =~ s/Jul/07/;        $month =~ s/Aug/08/;
        $month =~ s/Sep/09/;        $month =~ s/Oct/10/;   
        $month =~ s/Nov/11/;        $month =~ s/Dec/12/;
 $month;
}



#############################################################
# Fork to the background
#############################################################
sub forktoBg {
  local($sig) = @_;

  # Close term interaction 
   open(STDOUT, ">> /net/spangle1/student/poll9477/tst/bin/error.log");
   open(STDERR, ">> /net/spangle1/student/poll9477/tst/bin/error.log");
   open(STDIN,  "/dev/null");

   if ($pid = fork) {
	print "Forking:   @_ \n";
        exit(0);
   }
}



#############################################################
# Signal handler kills background process
#############################################################
sub handler { 
  local($sig) = @_;
  print "Caught a SIG$sig--shutting down:  $0\n";
  exit(0);
}
$SIG{INT} = \&handler;      # Set signal handler to die on request


1;

