#! &PERL& -I&INCDIR&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use Toollib;
use Datelib qw(hhmmss yyyymmdd);
use Getopt::Long;

@commandtypes = qw(STOR RETR);
open (PSR, ">> ./ftp.log") || die "Can't open file. $! $0 \n";


 forktoBg($0);
 $res = GetOptions('id=i',		\$daemonid);
 if ($res == 0) { 
	print "Error in command line arguments $0 \n"; 
 }
 $firstpass = 1;


while (!$do_exit) {
    $found = 0;
    &psPipe;
    sleep 2;
}

&delpid();


################################################################
# parse the ps -efl
################################################################

sub psPipe {		  	
 open(PS, "ps -efl|") || die "Can't open pipe for ps. $!\n";


 while (<PS>) {
   chop;

   ($flags,$state,$uid,$pid,$ppid,$cpu,$pri,$nice,$address,$size,
    $wchan,$stime,$data) = split(' ', $_, 13);

   if ($pid == $daemonid) {
     $_ = $stime;
     $cnt = tr/a-zA-Z0-9://;
     $found = 1;   
   
     if ($cnt > 3) { 
	($tty,$time,$command) = split(' ',$data,3); 
     }
     else {
        ($wday,$tty,$time,$command) = split(' ',$data,4);
        $stime = join(' ',$stime,$wday,"  ");
     }

    &checkCommand;
   }   
 }
 close(PS);

 if (!$found) {
   exit;
 }
}



################################################################
# Check for ftp command change - if found swap.
# Check for first pass 	       - if so initialize base variables
################################################################

sub checkCommand {

  ($daemon,$from_host,$user,$ftp_command,$ftp_file) = split(' ',$command);

  if ($firstpass) {  
    &initializeBaseVariables;
    $firstpass = 0;
    print PSR "$uid\t$pid\t$stime\t$command\t$hostname\n";  
    &CommandType;
  }

  if (&swap) {
    &initializeBaseVariables;
    print PSR "$uid\t$pid\t$stime\t$command\t$hostname\n";  
    &CommandType;
  }

}


################################################################
# Check for ftp command change - if found swap
################################################################

sub swap {
  if (($from_host ne $base_host) || ($user ne $base_user) ||
      ($ftp_command ne $base_ftp_command) || 
      ($ftp_file ne $base_ftp_file)) {
      $change = 1;
  } 
  else {
      $change = 0;
  }
$change;
}



################################################################
# Set base variables
################################################################

sub initializeBaseVariables {
   
  $base_host        = $from_host;      
  $base_user        = $user;
  $base_ftp_command = $ftp_command;
  $base_ftp_file    = $ftp_file;

}



################################################################
# Check for command types to alert hummer interface
################################################################

sub CommandType {

 foreach $command_type (@commandtypes) {
    if ($ftp_command =~ /$command_type/) {
	&sendAlert;
    }
 }
} 



################################################################
# Send Alert(PSR) to Hummer Interface
################################################################

sub sendAlert {
    $date = yyyymmdd();
    $current_time = hhmmss();
    $message = join('', "PSR[",$pid,"]     ",$command,"   ",$hostname);
    
    ToolI($message, $date, $current_time, $hostname, $logfile, "ftpmonitor");
}
