/******************************************************************
krb5_sock_cli.h
HummingBird Project - Deborah A. Frincke, PhD.
Summer 1997
Coded by: Jamie Marconi
Description: This class is used for kreberized client connections.  It
is also used to hadn off server connection to a socket after a connection
has been authenicated.
*******************************************************************/
/*
  Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _krb5_sock_cli_h
#define _krb5_sock_cli_h

#include "krb5_sock.h"     // kerberos socket base class
#include <string.h>
#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <netdb.h>

#define REPLAY_UNIQUE_NAME "_krb5_sock_cli_0.0"
#define KRB5_DEFAULT_OPTIONS 0

class krb5_sock_cli: public krb5_sock
{
  // Data;
  char *keytab_name; 
  char *principal_name; 

  // Methods;
 public:
  krb5_sock_cli();
  krb5_sock_cli(int asock, char* pservice);
  ~krb5_sock_cli();
  krb5_set_names(char *keytab, char *principal);
  int krb5_connect(char *remote_host, int port, char* pservice);
  int krb5_connect(char *remote_host, char* service);
  int krb5_s_auth();
  char * krb5_r_auth(char *keytab_name);
  int krb5_e_read(char *buf, size_t buflen);
  int krb5_e_write(char *buf);
};

#endif /* _krb5_sock_cli */
  
