#! &PERL&


#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

# demo script, has been tested with:
#  - Postgres-6.1
#  - apache_1.2
#  - mod_perl-1.0
#  - perl5.004

use CGI qw(:standard);
use Pg;
use strict;

use Sys::Hostname;
my $host = hostname();
my $inh = param('inh');

print header;
print start_html(-title=>'Add a new Hummer and Levels',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple'),
  "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>";
  
if ($inh eq "") {
  print h2('Error: Must specify inherited value'),
  "</center>";
}
else {
  print h1('Input a New Hummer and Levels');
  print "<H4><A HREF=\"levels.shtml\">Return to Levels Configuration Page</A></H4>";  
  if (!param('Action')) {
    print "<center>",
    h4('Name, IP, or Alias will work.'),
    start_form,
    "Hummer: ", textfield(-name=>'newip',-size=>40),br,
    "Trust Level: ", popup_menu(-name=>'trust',
				-values=> [ '1' , '2', '3', '4', '5' ]),br,
    "Cooperation Level: ", popup_menu(-name=>'coop',
				      -values=> [ '1' , '2', '3', '4', '5' ]),br,
    "Integrite Level: ", popup_menu(-name=>'integ',
				      -values=> [ '1' , '2', '3', '4', '5' ]),br,
    hidden(-name=>'inh',-default=>["$inh"]),br,
    submit('Action','Configure'),
    reset(),
    button(-value=>'Cancel',
	   -onclick=>"history.back()"),
    end_form,
    "</center>";
  }
  
  else {
    my $newip = param('newip');
    my $start_addr;
    my $end_addr;
    ($start_addr, $end_addr) = split(/-/,$newip);
    my $trust = param('trust');
    my $coop = param('coop');
    my $integ = param('integ');

    my $conn = Pg::connectdb("dbname = hummer_$host");
    ( PGRES_CONNECTION_OK eq $conn->status ) || exit;
    my $result = $conn->exec("select * from levels;");
    (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
    my $i;
    my $isthere;
    for ($i=0; $i < $result->ntuples; $i++) 
    {
      my $start = $result->getvalue($i,0);
      my $end = $result->getvalue($i,1);
      my $dbinh = $result->getvalue($i,5);
      if ($start eq $start_addr)
      {
        if ($end eq $end_addr)
        {
          if ($dbinh eq $inh)
          {
            $isthere = 1;
          }
        }
      }
    }

    if ($isthere) 
    {
      $result = $conn->exec("delete from levels where start_addr = '$start_addr' and end_addr = '$end_addr' and inh = $inh;");
    } 
    my $result = $conn->exec("insert into levels values ('$start_addr','$end_addr',$trust, $coop, $integ, $inh);");
    (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
    print "Host: $start_addr";
    if ($end_addr) {
      print "-$end_addr"; 
    }
    print "<br>with trust $trust, cooperation $coop, integrity $integ";
    print "<BR><BR>has been added to the trusts list."
  }
}
  


print end_html;
