#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI qw(:standard);
use Pg;
use strict;
use Socket;

use Sys::Hostname;
my $host = hostname();
my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

print header;
print start_html(-title=>'Peer Group Creation Interface',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple'),
  "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
  
  h1('Peer Group Creation Interface');
  print a({href=>"peer_create_help.html"},"<H3>Help</H3>"),
  "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>",
  "<HR WIDTH=\"87%\">",
  "<B><I><FONT SIZE=+2>Choose a Peer Group Name</FONT></I></B>";

if (param()) {

  my $name = param('name');
  my $peerlist = param('peerlist');
  my $email = param('email');
  my $conn = Pg::connectdb("dbname = hummer_$host");
  my $res  = $conn->exec("select pgroup from pgroups where pgroup = '$name';");
  my $grpchk = $res->getvalue(0,0);
  if ($grpchk eq $name) {
      print("You are already subscribed to a group with the name \"$name\".<BR>\n",
	    "You cannot create a group with same name as an existing group.<BR>\n");
      print p,
      "</center>";
      exit;
  } 
  print  ("<HR WIDTH=\"87%\">",
	  "<B><I>",
	  "<FONT SIZE=+2>Peer Group Created (Successfully Added Hosts Listed Below)",
	  "</FONT></I></B><P>");
  
  $hname = $host . "." . $domain;
  $ipaddress = &getaddress($hname);
  my $result = $conn->exec("insert into pgroups values ('$name', '$ipaddress', '$email');");
  my $peer;

  foreach $peer (split(/$/m, $peerlist)) 
  {
    $peer =~ s/\n//;
    $peer =~ s/\r//;
    if ($peer ne "") 
    {
	$hname = $peer;
	$ipaddress = &getaddress($hname);
        my $result = $conn->exec("select * from levels;");
        (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
        my $i;
        my $isthere;
        for ($i=0; $i < $result->ntuples; $i++) 
        {
          my $start = $result->getvalue($i,0);
          my $dbinh = $result->getvalue($i,5);
          if ($start eq $ipaddress)
          {
              if ($dbinh eq '0')
              {
                $isthere = 1;
              }
          }
        }

        if (!$isthere) 
        {
          $result = $conn->exec("insert into levels values ('$ipaddress','',1,1,1,0);");
        }
        $isthere = 0;
        $result = $conn->exec("select * from peers where pgroup = '$name';");
        for ($i=0; $i < $result->ntuples; $i++) 
        {
          my $start = $result->getvalue($i,1);
          if ($start eq $ipaddress)
          {
            $isthere = 1;
          }
        }
        if (!$isthere)
        {
          $result = $conn->exec("insert into peers values ('$name','$ipaddress',0,0);");
          (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
        }
    }
  }

  $hname = $host . "." . $domain;
  $ipaddress = &getaddress($hname);
  $result = $conn->exec("insert into peers values ('$name','$ipaddress',1,1);");
  $result = $conn->exec("delete from peers where mem_addr = '';");
  print "<table border=1><tr><th>Peer Group</th><th>Host Name</th><th>Host IP</th><th>Subscribed</th><th>Moderator</th></tr>\n";
  $result = $conn->exec("select * from peers where pgroup = '$name';");
  (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $sub = $result->getvalue($i,2);
      my $mod = $result->getvalue($i,3);
      $hosts = &getname($mem);
      print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td>";
      if ($sub eq 0) { print "<td>no</td>"; }
      if ($sub eq 1) { print "<td>yes</td>"; }
      if ($mod eq 0) { print "<td>no</td>"; }
      if ($mod eq 1) { print "<td>yes</td>"; }
      print "</tr>\n";
  }
  print "</table><BR><BR><BR>";
  print "Email: $email<br>";
}
else {

  
  print start_form,
  
  "Name:", textfield(-name=>'name',
		     -size=>'30'),

  "<h2>Enter the <i>Contact</i> email address</h2>",
  
  "Email:", textfield(-name=>'email',
		      -size=>'30'),
  
  "<H2>Enter the Hummers to be added to the above group in the box below.</H2>",
  
  textarea(-name=>'peerlist',
	   -rows=>'4',
	   -cols=>'50'),p,
  
  
  submit(-name=>'Create'),
  reset(),
  button(-value=>'Cancel',
	 -onclick=>"history.back()"),
  
  end_form;
}

print p,
  "</center>";

sub getaddress {
  my($hname) = @_;
  my $add  = '';
  my $addre;
  my $address=gethostbyname($hname);
  my @addr=unpack('C4',$address);
  foreach $addre (@addr) {
    $add = $add . $addre . ".";
  }
  chop $add;
  return $add;
}


sub getname {
    my($hname) = @_;

    my $n1 = index($hname,".");          
    my $s1 = substr($hname,0,$n1);                                              
    my $n2 = index($hname,".",$n1+1);
    my $s2 = substr($hname,$n1+1,$n2-($n1+1));
    my $n3 = index($hname,".",$n2+1);
    my $s3 = substr($hname,$n2+1,$n3-($n2+1));
    my $s4 = substr($hname,$n3+1);

    my @a= ($s1,$s2,$s3,$s4);
    my $addr=pack('C4',@a);

    my $names;
    my $alias;
    my $adrtype;
    my $length;
    my @address;
    ($names,$alias,$adrtype,$length,@address) = gethostbyaddr($addr,AF_INET);
    return $names;
}




































































































































