#! &PERL&

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI qw(:standard);
use Pg;
use strict;
use Socket;

use Sys::Hostname;
my $host = hostname();
my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

print header;
print start_html(-title=>'Peer Group Edit Interface',
		 -TEXT=>'black', 
		 -BGCOLOR=>'white',
		 -LINK=>'blue',
		 -VLINK=>'purple'),
    
    "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
    
  h1('Peer Group Edit Interface'),"<H3><A HREF=\"peer_edit_help.html\">Help</A></H3>",
    "<H4><A HREF=\"peer2peer.shtml\">Return to Peer Moderation Page</A></H4>",
    "<HR WIDTH=\"87%\">",
    "<B><FONT SIZE=+3>Current Peer Group is:</FONT></B>".
    
    start_form;

my $conn = Pg::connectdb("dbname = hummer_$host");
( PGRES_CONNECTION_OK eq $conn->status ) || exit;

$hname = $host . "." . $domain;
$ipaddress = &getaddress($hname);
my $result = $conn->exec("select * from pgroups where mod_addr='$ipaddress';");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

my @groupnames;
my $i;
for ($i=0; $i < $result->ntuples; $i++) {
  $groupnames[$i] = $result->getvalue($i,0);
}
my $group;
if (!param('pgroupname')) {
  $group = $groupnames[0];
}
else {
  $group =  param('pgroupname');
}

print popup_menu(-name=>'pgroupname',
		 -values=> [ @groupnames ],
		 -onChange=>'submit()'),
  
  "<HR WIDTH=\"51%\"></center>";

if (param('Action')) {
  print "<center><P><B><FONT SIZE=+3>Editing Results</FONT></B></P>";
 
  my $Action = param('Action');
  my $peername = param('peername');
  my $newip = param('newip');

  if ($Action eq 'Add') {
      $hname=$newip;
      $ipaddress = &getaddress($hname);
      if ($ipaddress ne '') 
      {
        my $result = $conn->exec("select * from levels;");
        (PGRES_TUPLES_OK eq $result->resultStatus) || exit;
        my $i;
        my $isthere;
        for ($i=0; $i < $result->ntuples; $i++) 
        {
          my $start = $result->getvalue($i,0);
          my $dbinh = $result->getvalue($i,5);
          if ($start eq $ipaddress)
          {
              if ($dbinh eq '0')
              {
                $isthere = 1;
              }
          }
        }

        if (!$isthere) 
        {
          $result = $conn->exec("insert into levels values ('$ipaddress','',1,1,1,0);");
        }
        $isthere = 0;
        $result = $conn->exec("select * from peers where pgroup = '$group';");
        for ($i=0; $i < $result->ntuples; $i++) 
        {
          my $start = $result->getvalue($i,1);
          if ($start eq $ipaddress)
          {
            $isthere = 1;
          }
        }
        if ($isthere)
        {
          print "\"$hname\" is already a member of the peer group.";
        }
        else
        {
          $result = $conn->exec("insert into peers values ('$group','$ipaddress',0,0);");
          (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
          print "$ipaddress was <i>Added</i> to the Peer Group<br>";
        }
      }
      else {
	  print "\"$hname\" is not a valid name.";
      }
      $Action = 'none';
  }
  elsif ($Action eq 'Remove') {
      $hname = $host . "." . $domain;
      $ipaddress = &getaddress($hname);
      if ($peername eq $ipaddress) {
	  $result = $conn->exec("delete from peers where pgroup='$group';");
	  $result = $conn->exec("delete from pgroups where pgroup='$group';");
	  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
	  print "You have just removed yourself as Peer Moderator<br>";
      }
      else {
	  $result = $conn->exec("delete from peers where mem_addr='$peername' and pgroup ='$group';");
	  (PGRES_COMMAND_OK eq $result->resultStatus) || exit;
	  print "$peername was <i>Removed</i> from the Peer Group<br>";
      }
      $Action = 'none';
  }   
  print "<HR WIDTH=\"51%\">";
   
}
print "<center><P><B><FONT SIZE=+3>Peer Group Status</FONT></B></P>";
print "<table border=1><tr><th>Peer Group</th><th>Host Name</th><th>Host IP</th><th>Subscribed</th><th>Moderator</th></tr>\n";
$result = $conn->exec("select * from peers where pgroup = '$group';");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;
my $i;
my $hosts;
for ($i=0; $i < $result->ntuples; $i++) {
    my $grp = $result->getvalue($i,0);
    my $mem = $result->getvalue($i,1);
    my $sub = $result->getvalue($i,2);
    my $mod = $result->getvalue($i,3);
    $hosts = &getname($mem);
    print "<tr><td>$grp</td><td>$hosts</td><td>$mem</td>";
    if ($sub eq 0) { print "<td>no</td>"; }
    if ($sub eq 1) { print "<td>yes</td>"; }
    if ($mod eq 0) { print "<td>no</td>"; }
    if ($mod eq 1) { print "<td>yes</td>"; }
    print "</tr>\n";
}
print "</table></center><BR><BR><BR>";

$result = $conn->exec("select * from peers where pgroup = '$group';");
(PGRES_TUPLES_OK eq $result->resultStatus) || die "select members: $!";
my @peers;
for ($i=0; $i < $result->ntuples; $i++) {
  $peers[$i] = $result->getvalue($i,1);  
}
print "<HR WIDTH=\"51%\">","<center><P><B><FONT SIZE=+3>Editing Functions</FONT></B></P>";

print "<table><tr><td>",
  "<B><FONT SIZE=+1><I>Add</I> a Hummer to the Peer Group</FONT></B>",br,
  textfield(-name=>'newip',
	    -size=>20),
  submit('Action','Add'),
  reset(),
  "<HR ALIGN=LEFT WIDTH=\"17%\">",
  "<B><FONT SIZE=+1><I>Remove</I> a Hummer from the Peer Group</FONT></B>",br,
  popup_menu(-name=>'peername',
	     -values=>[ @peers ] ),
  submit('Action','Remove'),
  reset(),
  end_form,
  "</td></tr></table>";


print "</center><P>";
  

sub getaddress {
  my($hname) = @_;
  my $add  = '';
  my $addre;
  my $address=gethostbyname($hname);
  my @addr=unpack('C4',$address);
  foreach $addre (@addr) {
    $add = $add . $addre . ".";
  }
  chop $add;
  return $add;
}


sub getname {
    my($hname) = @_;

    my $n1 = index($hname,".");          
    my $s1 = substr($hname,0,$n1);                                              
    my $n2 = index($hname,".",$n1+1);
    my $s2 = substr($hname,$n1+1,$n2-($n1+1));
    my $n3 = index($hname,".",$n2+1);
    my $s3 = substr($hname,$n2+1,$n3-($n2+1));
    my $s4 = substr($hname,$n3+1);

    my @a= ($s1,$s2,$s3,$s4);
    my $addr=pack('C4',@a);

    my $names;
    my $alias;
    my $adrtype;
    my $length;
    my @address;
    ($names,$alias,$adrtype,$length,@address) = gethostbyaddr($addr,AF_INET);
    return $names;
}















