#! &PERL&


##############################################################
#      save_config.cgi
#
#      Hummingbird 
#      Made: 7/01/98
#      Modified: 7/03/98
#      Joel Marlow
#      
#  This script is used to save the configuration of the current hummer. It helps
#  for stability in case postgress goes down.
##############################################################

#
# Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI;
use Pg;
use strict;
use Socket;
use Sys::Hostname;

my $query = new CGI;
my $host = hostname();

my $domain = `domainname`;
chop $domain;
my $hname;
my $ipaddress;

open (TEMP, ">save_$host.dat") or die "Cannot write file"; 
print  $query->header,
    "<html><head><TITLE>Save Hummer Configuration</TITLE></head>\n
     <BODY TEXT=black BGCOLOR=white LINK=blue VLINK=purple>\n",
    "<CENTER><IMG SRC=\"hummer2.JPG\" BORDER=0 HEIGHT=154 WIDTH=377>",
    "<H1>Save Hummer Configuration </H1>",
    "<HR WIDTH=\"87%\">";

print "<H4><A HREF=\"index.html\">Return to Hummer Homepage</A></H4>";
print "<P><HR ALIGN=CENTER WIDTH=\"51%\"><br>";

my $conn = Pg::connectdb("dbname = hummer_$host");
# $msg = $conn->errorMessage;
 ( PGRES_CONNECTION_OK eq $conn->status ) || die "Can't Connect to DB\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the accept_list 
#**********************************************
#print TEMP "#*accept_list\n";

my $result = $conn->exec("select * from accept_list;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $start_addr = $result->getvalue($i,1);
      my $end_addr = $result->getvalue($i,2);
      my $inh = $result->getvalue($i,3);
      print TEMP "$filter|$start_addr|$end_addr|$inh\n";
  }
  print TEMP "#@\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the config_time
#**********************************************
#print TEMP "#*config_time\n";
my $result = $conn->exec("select * from config_time;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $ctime = $result->getvalue($i,0);
      print TEMP "$ctime\n";
  }
  print TEMP "#@\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the filter
#**********************************************
#print TEMP "#*filter\n";

my $result = $conn->exec("select * from filter;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $expression = $result->getvalue($i,0);
      my $date_start = $result->getvalue($i,1);
      my $date_end = $result->getvalue($i,2);
      my $time_start = $result->getvalue($i,3);
      my $time_end = $result->getvalue($i,4);
      my $trust = $result->getvalue($i,5);
      my $coop = $result->getvalue($i,6);
      my $integ = $result->getvalue($i,7);
      my $log = $result->getvalue($i,8);
      my $alert = $result->getvalue($i,9);
      my $inh = $result->getvalue($i,10);

      print TEMP "$expression|$date_start|$date_end|$time_start|$time_end|";
      print TEMP "$trust|$coop|$integ|$log|$alert|$inh\n";
  }
  print TEMP "#@\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the forward_list
#**********************************************
#print TEMP "#*forward_list\n";

my $result = $conn->exec("select * from forward_list;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      print TEMP "$filter|$mem|$inh\n";
  }
  print TEMP "#@\n";


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the forward_peer 
#**********************************************

#print TEMP "#*forward_peer\n";

my $result = $conn->exec("select * from forward_peer;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $filter = $result->getvalue($i,0);
      my $pgroup = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      print TEMP "$filter|$pgroup|$inh\n";
  }
  print TEMP "#@\n";
  


#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the kill_file 
#**********************************************
#print TEMP "#*kill_file\n";

my $result = $conn->exec("select * from kill_file;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $start_addr = $result->getvalue($i,0);
      my $end_addr = $result->getvalue($i,1);
      my $inh = $result->getvalue($i,2);
      print TEMP "$start_addr|$end_addr|$inh\n";
  }
  print TEMP "#@\n";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the levels 
#**********************************************
#print TEMP "#*levels\n";

my $result = $conn->exec("select * from levels;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $start_addr = $result->getvalue($i,0);
      my $end_addr = $result->getvalue($i,1);
      my $trust = $result->getvalue($i,2);
      my $coop = $result->getvalue($i,3);
      my $integ = $result->getvalue($i,4);
      my $inh = $result->getvalue($i,5);
      print TEMP "$start_addr|$end_addr|$trust|$coop|$integ|$inh\n";
  }
  print TEMP "#@\n";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the manager 
#**********************************************
#print TEMP "#*manager\n";

my $result = $conn->exec("select * from manager;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $manager = $result->getvalue($i,0);
      print TEMP "$manager\n";
  }
  print TEMP "#@\n";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the peers 
#**********************************************
#print TEMP "#*peers\n";

my $result = $conn->exec("select * from peers;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $sub = $result->getvalue($i,2);
      my $mod = $result->getvalue($i,3);
      print TEMP "$grp|$mem|$sub|$mod\n";
  }
  print TEMP "#@\n";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the pgroups 
#**********************************************
#print TEMP "#*pgroups\n";

my $result = $conn->exec("select * from pgroups;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  my $hosts;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $grp = $result->getvalue($i,0);
      my $mem = $result->getvalue($i,1);
      my $email = $result->getvalue($i,2);
      print TEMP "$grp|$mem|$email\n";
  }
  print TEMP "#@\n";
  
# THIS SECTION WAS COMMENTED OUT BECAUSE IT DOES NOT NEED TO BE 
# SAVED FOR THE HUMMER
#
#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the pid 
#**********************************************
#print TEMP "#*pid\n";

#my $result = $conn->exec("select * from pid;");
#(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

#  my $i;
#  for ($i=0; $i < $result->ntuples; $i++) {
#      my $name = $result->getvalue($i,0);
#      my $pid = $result->getvalue($i,1);
#      print TEMP "$name|$pid\n";
#  }
#  print TEMP "#@\n";
  

#**********************************************
#  JM 7/1/98
#  This section writes to the screen and the temp.dat file the data 
#  from the subordinates 
#**********************************************
#print TEMP "#*subordinates\n";

my $result = $conn->exec("select * from subordinates;");
(PGRES_TUPLES_OK eq $result->resultStatus) || exit;

  my $i;
  for ($i=0; $i < $result->ntuples; $i++) {
      my $hum_name = $result->getvalue($i,0);
      my $subordinate = $result->getvalue($i,1);
      print TEMP "$hum_name|$subordinate\n";
  }
  print TEMP "#@\n";

 print "<H4>The Configuration for this Hummer has been saved</H4></center>";




