/******************************************************************
sock.h
HummingBird Project - Deborah A. Frincke, PhD.
Spring 1998
Coded by: Jamie Marconi
Description: This class is the class definition for the base socket
 either kreberized or not.
*******************************************************************/
/*
 Copyright (C) 1997-1998 The HummingBird Project - hummer@cs.uidaho.edu

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _sock_h
#define _sock_h

#include "config.h"

#include "Print_Error.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <ctype.h>
#include <netdb.h>

#ifdef KRB5
extern "C" {
#include <krb5.h>
#include <com_err.h>
}
#endif

#define REPLAY_UNIQUE_NAME "_krb5_sock_cli_0.1"
#define KRB5_DEFAULT_OPTIONS 0

#define KERBERIZED_SOCKET "KRB5_EN"
#define UN_KERBERIZED_SOCKET "NO_KRB5"

#define KRB5_SOCK_VERSION "0.1"
#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

class sock {

 protected:
  // Data
  int xmit_time;
  
  char *service;
  char *keytab_name; 
  char *principal_name; 

  int sock;
  int kerberized;

  char full_rmt_hname[MAXHOSTNAMELEN];
#ifdef BROKEN_STREAMS_SOCKETS
  char full_loc_hname[MAXHOSTNAMELEN];
#endif

  struct sockaddr_in *rmt_sockaddr;
  struct sockaddr_in *loc_sockaddr;
  int sin_len;

#ifdef KRB5
  krb5_error_code retval;
  krb5_context context;
  krb5_auth_context auth_context;
#endif  

  // Methods
  int read_wait(void);
  int is_kerb5();
  
 public:
  sock();
  ~sock();
  int get_fd();
  void set_fd(int new_fd);
  int create();
  int close();
  
  int send_auth();
  int send_auth(char * pservice);
  char * recv_auth(char *keytab_name);
  int read(char *buf, size_t buflen);
  int write(char *buf);
};
  
#endif _sock_h
